--[[ svn: $Id: ASSinTrade.lua 32 2009-02-24 00:20:30Z crashmstr $

ASSinTrade
    ...because there are a lot of them

By crashmstr (wowzn@crashmstr.com)

Basic structure and code ripped from TasteTheNaimbow (Thank you Guillotine!)

Change Log:

v0.4
   - update for 3.x changes

v0.3
	- user must currently make OMGWTFBBQ chat frame to shunt "bad" Trade
	-chat into. Still looking into how to do this in code
	- First Alpha release to testers :)
v0.2
	- more Ace2-ification. save state. add alpha
v0.1
	- Initial internal version

--]]

ASSinTrade = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceHook-2.1", "AceDB-2.0")

local options = { 
    type='group',
    args = {
        on = {
            type = 'toggle',
            name = 'Turned On',
            desc = 'Toggles the function of ASSinTrade on/off',
            get = "IsTurnedOn",
            set = "ToggleTurnedOn",
        },
        shunt = {
            type = 'toggle',
            name = 'Shunt the Trade spam to the OMGWTFBBQ Channel Frame',
            desc = 'Toggles the shunting of the Trade spam to the OMGWTFBBQ chat frame',
            get = "IsBBQShunt",
            set = "ToggleBBQShunt"
        },
        debug = {
            type = 'toggle',
            name = 'Debug window',
            desc = 'Toggles the debug window',
            get = "IsDebug",
            set = "ToggleDebug"
        },
    },
}

ASSinTrade:RegisterDB("ASSinTradeDB", "ASSinTradeDBPerChar")
ASSinTrade:RegisterDefaults('profile', {
										 turnedOn = true,
										 bbqShunt = true,
										 debug = false,
										 matchKeep = {
											 {"[wW][tT][bBsStT]",true},
											 {"[lL][fF][wWeE]",true},
											 {"LFEnchant",true},
											 {"LF%dM?",true},
											 {"[lL][fF][gG]",true},
											 {"AH",true},
											 {"looking for work",true},
											 {"lockpick",true},
											 {"[sS][eE][lL][lL][iI][nN][gG]",true},
											 {"3[vV]3",true},
											 {"5[vV]5",true},
									 } } )


function ASSinTrade:IsTurnedOn() return self.db.profile.turnedOn; end
function ASSinTrade:ToggleTurnedOn() self.db.profile.turnedOn = not self.db.profile.turnedOn; end
function ASSinTrade:IsBBQShunt() return self.db.profile.bbqShunt; end
function ASSinTrade:ToggleBBQShunt() self.db.profile.bbqShunt = not self.db.profile.bbqShunt; end
function ASSinTrade:IsDebug() return self.db.profile.debug; end
function ASSinTrade:ToggleDebug() self.db.profile.debug = not self.db.profile.debug; end

local ASSinTrade_original_ChatFrame_OnEvent = ChatFrame_OnEvent

function ASSinTrade:OnInitialize()
    -- Called when the addon is loaded
 
end

function ASSinTrade:OnEnable()
	-- Called when the addon is enabled
	self:RegisterChatCommand("/assintrade", "/assint", options)
	self:Print("|cFFFF0000A|rnti-|cFFFF0000S|rpam |cFFFF0000S|roftware: Block Spam in Trade Chat (ASSinTrade) ENABLED! (because there are a lot of asses in trade)")
end

function ASSinTrade:OnDisable()
    -- Called when the addon is disabled
	self:Print("|cFFFF0000A|rnti-|cFFFF0000S|rpam |cFFFF0000S|roftware: Block Spam in Trade Chat (ASSinTrade) DIS-ENABLED!")
end


local shuntFrame = nil
local debugFrame = nil

function FindOrCreateChatWindow(window, create)
	local frame = nil
	for i=1,NUM_CHAT_WINDOWS do
		name, fontSize, r, g, b, alpha, shown, locked, docked = GetChatWindowInfo(i)
		--DEFAULT_CHAT_FRAME:AddMessage(name .. " found")
		if (name == window) then
			SetChatWindowShown(i, true)
			frame = getglobal("ChatFrame" .. i)
			frame:AddMessage("ASSinTrade: found the frame " .. window);
		end
	end

	--[[
	if frame == nil and create then
		frame = CreateFrame("Frame", window, UIParent)
		setglobal("ChatFrame" .. NUM_CHAT_WINDOWS+1, frame)
		frame:Show()
		frame:AddMessage("ASSinTrade: created the frame " .. window)
		
		for i=1,NUM_CHAT_WINDOWS do
			name, fontSize, r, g, b, alpha, shown, locked, docked = GetChatWindowInfo(i)
			--DEFAULT_CHAT_FRAME:AddMessage(name .. " found")
			if (name == window) then
				SetChatWindowShown(i, true)
				SetChatWindowDocked(i, true)
			end
		end
	end
	--]]

	return frame
end

----------------------------------------ChatFrame--------------------------
local lastArg1
local lastArg2

function SendMessageToChat(frame, message)
	if frame then
		frame:AddMessage(message)
	end
end

function ASSinTrade_new_ChatFrame_OnEvent(...)
	local showIt = true
	local filterFuncList = ChatFrame_GetMessageEventFilters("CHAT_MSG_CHANNEL")

	if debugFrame == nil and ASSinTrade.db.profile.debug == true then
		debugFrame = FindOrCreateChatWindow("ASSDebug", true)
	end

	if ASSinTrade.db.profile.bbqShunt and shuntFrame == nil then
		shuntFrame = FindOrCreateChatWindow("OMGWTFBBQ", true)
	end

	if (filterFuncList and ASSinTrade.db.profile.turnedOn) then
		--ASSinTrade.original_CHAT_CHANNEL_GET = CHAT_CHANNEL_GET;
		if arg4=="2. Trade - City" then
			showIt = false
			
			SendMessageToChat(debugFrame, "arg1: " .. arg1 .. " arg2: " .. arg2)
			
			for i,matchIt in ipairs(ASSinTrade.db.profile.matchKeep) do
				SendMessageToChat(debugFrame, "Checking for Match with " .. matchIt[1])
				if matchIt[2] and string.find(arg1, matchIt[1]) then
					SendMessageToChat(debugFrame, "Matched!")
					showIt = true
					break
				end
			end
			
			if (showIt == false) then
				if (ASSinTrade.db.profile.alphaAway == true) then
					SendMessageToChat(debugFrame, "AlphaEnabled :(")
					showIt = true;
					CHAT_CHANNEL_GET = "|c3FFFFFFFASSinTrade|r";
				elseif (ASSinTrade.db.profile.bbqShunt == true and shuntFrame ~= nil) then
					if lastArg1 ~= arg1 or lastArg2 ~= arg2 then
						SendMessageToChat(shuntFrame, string.format(CHAT_CHANNEL_GET, arg2) .. arg1)
						lastArg1, lastArg2 = arg1, arg2
					end
				end
			end
		end
	end
--[[
	if (showIt) then
		ASSinTrade_original_ChatFrame_OnEvent(event);
	end
	
	if (event == "CHAT_MSG_CHANNEL") then
		CHAT_CHANNEL_GET = ASSinTrade.original_CHAT_CHANNEL_GET;
	end
--]]
	return not showIt
end

--ChatFrame_OnEvent = ASSinTrade_new_ChatFrame_OnEvent
ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL", ASSinTrade_new_ChatFrame_OnEvent)
